# ncurses 5.9 - patch  - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 5.9 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 5.9 are in the subdirectory
# 	ftp://invisible-island.net/ncurses/5.9
#
# ------------------------------------------------------------------------------
# ftp://invisible-island.net/ncurses/5.9/ncurses-5.9-20131027.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Mon Oct 28 08:09:20 UTC 2013
# ------------------------------------------------------------------------------
# Ada95/make-tar.sh                        |   13 ++++++++-----
# MANIFEST                                 |    1 +
# NEWS                                     |    8 +++++++-
# dist.mk                                  |    4 ++--
# ncurses/curses.priv.h                    |    4 ++--
# ncurses/tinfo/lib_cur_term.c             |   19 ++++++++-----------
# package/debian-mingw/changelog           |    4 ++--
# package/debian-mingw64/changelog         |    4 ++--
# package/debian/changelog                 |    4 ++--
# package/mingw-ncurses.nsi                |    4 ++--
# package/mingw-ncurses.spec               |    8 ++++----
# package/ncurses.spec                     |   10 +++++-----
# test/make-tar.sh                         |   13 ++++++++-----
# test/package/mingw-ncurses-examples.spec |   14 ++++++++------
# 14 files changed, 61 insertions(+), 49 deletions(-)
# ------------------------------------------------------------------------------
Index: Ada95/make-tar.sh
Prereq:  1.12 
--- ncurses-5.9-20131019+/Ada95/make-tar.sh	2011-03-26 19:07:38.000000000 +0000
+++ ncurses-5.9-20131027/Ada95/make-tar.sh	2013-10-26 23:10:24.000000000 +0000
@@ -1,7 +1,7 @@
 #!/bin/sh
-# $Id: make-tar.sh,v 1.12 2011/03/26 19:07:38 tom Exp $
+# $Id: make-tar.sh,v 1.14 2013/10/26 23:10:24 tom Exp $
 ##############################################################################
-# Copyright (c) 2010,2011 Free Software Foundation, Inc.                     #
+# Copyright (c) 2010-2011,2013 Free Software Foundation, Inc.                #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
 # copy of this software and associated documentation files (the "Software"), #
@@ -66,11 +66,11 @@
 make_changelog() {
 	test -f $1 && chmod u+w $1
 	cat >$1 <<EOF
-`echo $PKG_NAME|tr '[A-Z]' '[a-z]'` ($NCURSES_PATCH) unstable; urgency=low
+`echo $PKG_NAME|tr '[A-Z]' '[a-z]'` ($NCURSES_MAJOR.$NCURSES_MINOR-$NCURSES_PATCH) unstable; urgency=low
 
   * snapshot of ncurses subpackage for $PKG_NAME.
 
- -- `head -1 $HOME/.signature`  `date -R`
+ -- `head -n 1 $HOME/.signature`  `date -R`
 EOF
 }
 
@@ -108,7 +108,10 @@
 do
 	edit_specfile $spec
 done
-make_changelog $BUILD/$ROOTNAME/package/debian/changelog
+for spec in $BUILD/$ROOTNAME/package/debian*
+do
+	make_changelog $spec/changelog
+done
 
 cp -p ../man/MKada_config.in $BUILD/$ROOTNAME/doc/
 if test -z "$NO_HTML_DOCS"
Index: MANIFEST
--- ncurses-5.9-20131019+/MANIFEST	2013-10-12 21:51:51.000000000 +0000
+++ ncurses-5.9-20131027/MANIFEST	2013-10-26 00:53:43.000000000 +0000
@@ -1106,6 +1106,7 @@
 ./test/package/debian/rules
 ./test/package/debian/source/format
 ./test/package/debian/watch
+./test/package/mingw-ncurses-examples.spec
 ./test/package/ncurses-examples.spec
 ./test/programs
 ./test/railroad.c
Index: NEWS
Prereq:  1.2122 
--- ncurses-5.9-20131019+/NEWS	2013-10-20 00:08:12.000000000 +0000
+++ ncurses-5.9-20131027/NEWS	2013-10-28 00:17:08.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.2122 2013/10/20 00:08:12 tom Exp $
+-- $Id: NEWS,v 1.2126 2013/10/28 00:17:08 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,12 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20131027
+	+ correct/simplify ifdef's for cur_term versus broken-linker and
+	  reentrant options (report by Jean-Pierre Flori, cf: 20090530).
+	+ modify release/version combinations in test build-scripts to make
+	  them more consistent with other packages.
+
 20131019
 	+ add nc_mingw.h to installed headers for MinGW port; needed for
 	  compiling ncurses-examples.
Index: dist.mk
Prereq:  1.950 
--- ncurses-5.9-20131019+/dist.mk	2013-10-19 18:39:58.000000000 +0000
+++ ncurses-5.9-20131027/dist.mk	2013-10-27 10:27:05.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.950 2013/10/19 18:39:58 tom Exp $
+# $Id: dist.mk,v 1.952 2013/10/27 10:27:05 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 5
 NCURSES_MINOR = 9
-NCURSES_PATCH = 20131019
+NCURSES_PATCH = 20131027
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: ncurses/curses.priv.h
Prereq:  1.527 
--- ncurses-5.9-20131019+/ncurses/curses.priv.h	2013-08-31 17:02:41.000000000 +0000
+++ ncurses-5.9-20131027/ncurses/curses.priv.h	2013-10-28 00:02:27.000000000 +0000
@@ -34,7 +34,7 @@
  ****************************************************************************/
 
 /*
- * $Id: curses.priv.h,v 1.527 2013/08/31 17:02:41 tom Exp $
+ * $Id: curses.priv.h,v 1.528 2013/10/28 00:02:27 tom Exp $
  *
  *	curses.priv.h
  *
@@ -350,7 +350,7 @@
 #define HasTerminal(sp)      (((sp) != 0) && (0 != ((sp)->_term)))
 #define IsValidScreen(sp)    (HasTerminal(sp) && !IsPreScreen(sp))
 
-#if BROKEN_LINKER || USE_REENTRANT
+#if USE_REENTRANT
 #define CurTerm              _nc_prescreen._cur_term
 #else
 #define CurTerm              cur_term
Index: ncurses/tinfo/lib_cur_term.c
Prereq:  1.31 
--- ncurses-5.9-20131019+/ncurses/tinfo/lib_cur_term.c	2012-11-18 02:12:43.000000000 +0000
+++ ncurses-5.9-20131027/ncurses/tinfo/lib_cur_term.c	2013-10-28 00:10:27.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2010,2012 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2012,2013 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -39,14 +39,12 @@
 #include <curses.priv.h>
 #include <termcap.h>		/* ospeed */
 
-MODULE_ID("$Id: lib_cur_term.c,v 1.31 2012/11/18 02:12:43 tom Exp $")
+MODULE_ID("$Id: lib_cur_term.c,v 1.32 2013/10/28 00:10:27 tom Exp $")
 
 #undef CUR
 #define CUR termp->type.
 
-#if BROKEN_LINKER && !USE_REENTRANT
-NCURSES_EXPORT_VAR(TERMINAL *) cur_term = 0;
-#elif BROKEN_LINKER || USE_REENTRANT
+#if USE_REENTRANT
 
 NCURSES_EXPORT(TERMINAL *)
 NCURSES_SP_NAME(_nc_get_cur_term) (NCURSES_SP_DCL0)
@@ -55,6 +53,7 @@
 }
 
 #if NCURSES_SP_FUNCS
+
 NCURSES_EXPORT(TERMINAL *)
 _nc_get_cur_term(void)
 {
@@ -87,10 +86,10 @@
     oldterm = cur_term;
     if (SP_PARM)
 	SP_PARM->_term = termp;
-#if BROKEN_LINKER && !USE_REENTRANT
-    cur_term = termp;
-#else
+#if USE_REENTRANT
     CurTerm = termp;
+#else
+    cur_term = termp;
 #endif
     if (termp != 0) {
 #ifdef USE_TERM_DRIVER
@@ -133,9 +132,7 @@
 	TERMINAL_CONTROL_BLOCK *TCB = (TERMINAL_CONTROL_BLOCK *) termp;
 #endif
 	TERMINAL *cur = (
-#if BROKEN_LINKER && !USE_REENTRANT
-			    cur_term
-#elif BROKEN_LINKER || USE_REENTRANT
+#if USE_REENTRANT
 			    NCURSES_SP_NAME(_nc_get_cur_term) (NCURSES_SP_ARG)
 #else
 			    cur_term
Index: package/debian-mingw/changelog
--- ncurses-5.9-20131019+/package/debian-mingw/changelog	2013-10-19 18:39:58.000000000 +0000
+++ ncurses-5.9-20131027/package/debian-mingw/changelog	2013-10-27 10:27:05.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (5.9-20131019) unstable; urgency=low
+ncurses6 (5.9-20131027) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 19 Oct 2013 14:39:58 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 27 Oct 2013 06:27:05 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-5.9-20131019+/package/debian-mingw64/changelog	2013-10-19 18:39:58.000000000 +0000
+++ ncurses-5.9-20131027/package/debian-mingw64/changelog	2013-10-27 10:27:05.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (5.9-20131019) unstable; urgency=low
+ncurses6 (5.9-20131027) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 19 Oct 2013 14:39:58 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 27 Oct 2013 06:27:05 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-5.9-20131019+/package/debian/changelog	2013-10-19 18:39:58.000000000 +0000
+++ ncurses-5.9-20131027/package/debian/changelog	2013-10-27 10:27:05.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (5.9-20131019) unstable; urgency=low
+ncurses6 (5.9-20131027) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 19 Oct 2013 14:39:58 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 27 Oct 2013 06:27:05 -0400
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/mingw-ncurses.nsi
Prereq:  1.7 
--- ncurses-5.9-20131019+/package/mingw-ncurses.nsi	2013-10-19 20:17:03.000000000 +0000
+++ ncurses-5.9-20131027/package/mingw-ncurses.nsi	2013-10-27 10:27:05.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.7 2013/10/19 20:17:03 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.9 2013/10/27 10:27:05 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "5"
 !define VERSION_MINOR "9"
 !define VERSION_YYYY  "2013"
-!define VERSION_MMDD  "1019"
+!define VERSION_MMDD  "1027"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-5.9-20131019+/package/mingw-ncurses.spec	2013-10-19 18:39:58.000000000 +0000
+++ ncurses-5.9-20131027/package/mingw-ncurses.spec	2013-10-27 16:12:33.000000000 +0000
@@ -2,11 +2,11 @@
 
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
-Release: 5.9
-Version: 20131019
+Version: 5.9
+Release: 20131027
 License: X11
 Group: Development/Libraries
-Source: ncurses-%{release}-%{version}.tgz
+Source: ncurses-%{version}-%{release}.tgz
 # URL: http://invisible-island.net/ncurses/
 
 BuildRequires:  mingw32-filesystem >= 95
@@ -74,7 +74,7 @@
 	--without-tests
 
 %define debug_package %{nil}
-%setup -q -n ncurses-%{release}-%{version}
+%setup -q -n ncurses-%{version}-%{release}
 
 %build
 mkdir BUILD-W32
Index: package/ncurses.spec
--- ncurses-5.9-20131019+/package/ncurses.spec	2013-10-19 18:39:58.000000000 +0000
+++ ncurses-5.9-20131027/package/ncurses.spec	2013-10-27 22:29:35.000000000 +0000
@@ -1,10 +1,10 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
-Release: 5.9
-Version: 20131019
+Version: 5.9
+Release: 20131027
 License: X11
 Group: Development/Libraries
-Source: ncurses-%{release}-%{version}.tgz
+Source: ncurses-%{version}-%{release}.tgz
 # URL: http://invisible-island.net/ncurses/
 
 %define CC_NORMAL -Wall -Wstrict-prototypes -Wmissing-prototypes -Wshadow -Wconversion
@@ -22,7 +22,7 @@
 %prep
 
 %define debug_package %{nil}
-%setup -q -n ncurses-%{release}-%{version}
+%setup -q -n ncurses-%{version}-%{release}
 
 %build
 CFLAGS="%{CC_NORMAL}" \
@@ -85,7 +85,7 @@
 * Sat Mar 09 2013 Thomas E. Dickey
 - add --with-cxx-shared option to demonstrate c++ binding as shared library
 
-* Sat Oct 26 2012 Thomas E. Dickey
+* Sat Oct 27 2012 Thomas E. Dickey
 - add ncurses program as "ncurses6" to provide demonstration.
 
 * Fri Jun 08 2012 Thomas E. Dickey
Index: test/make-tar.sh
Prereq:  1.10 
--- ncurses-5.9-20131019+/test/make-tar.sh	2011-03-26 20:46:51.000000000 +0000
+++ ncurses-5.9-20131027/test/make-tar.sh	2013-10-26 23:11:43.000000000 +0000
@@ -1,7 +1,7 @@
 #!/bin/sh
-# $Id: make-tar.sh,v 1.10 2011/03/26 20:46:51 tom Exp $
+# $Id: make-tar.sh,v 1.12 2013/10/26 23:11:43 tom Exp $
 ##############################################################################
-# Copyright (c) 2010,2011 Free Software Foundation, Inc.                     #
+# Copyright (c) 2010-2011,2013 Free Software Foundation, Inc.                #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
 # copy of this software and associated documentation files (the "Software"), #
@@ -66,11 +66,11 @@
 make_changelog() {
 	test -f $1 && chmod u+w $1
 	cat >$1 <<EOF
-`echo $PKG_NAME|tr '[A-Z]' '[a-z]'` ($NCURSES_PATCH) unstable; urgency=low
+`echo $PKG_NAME|tr '[A-Z]' '[a-z]'` ($NCURSES_MAJOR.$NCURSES_MINOR-$NCURSES_PATCH) unstable; urgency=low
 
   * snapshot of ncurses subpackage for $PKG_NAME.
 
- -- `head -1 $HOME/.signature`  `date -R`
+ -- `head -n 1 $HOME/.signature`  `date -R`
 EOF
 }
 
@@ -108,7 +108,10 @@
 do
 	edit_specfile $spec
 done
-make_changelog $BUILD/$ROOTNAME/package/debian/changelog
+for spec in $BUILD/$ROOTNAME/package/debian*
+do
+	make_changelog $spec/changelog
+done
 
 cp -p $SOURCE/NEWS $BUILD/$ROOTNAME
 
Index: test/package/mingw-ncurses-examples.spec
Prereq:  1.1 
--- ncurses-5.9-20131019+/test/package/mingw-ncurses-examples.spec	2013-10-19 22:04:58.000000000 +0000
+++ ncurses-5.9-20131027/test/package/mingw-ncurses-examples.spec	2013-10-26 23:30:21.000000000 +0000
@@ -1,14 +1,16 @@
+Summary: ncurses-examples - example/test programs from ncurses
 %?mingw_package_header
 
 %define AppProgram ncurses-examples
-# $Id: mingw-ncurses-examples.spec,v 1.1 2013/10/19 22:04:58 tom Exp $
-Summary: shared libraries for terminal handling
+%define AppVersion MAJOR.MINOR
+%define AppRelease YYYYMMDD
+# $Id: mingw-ncurses-examples.spec,v 1.3 2013/10/26 23:30:21 tom Exp $
 Name: mingw32-ncurses6-examples
-Release: 5.9
-Version: 20131019
+Version: %{AppVersion}
+Release: %{AppRelease}
 License: X11
 Group: Development/Libraries
-Source: ncurses-examples-%{version}.tgz
+Source: ncurses-examples-%{release}.tgz
 # URL: http://invisible-island.net/ncurses/
 
 BuildRequires:  mingw32-ncurses6
@@ -57,7 +59,7 @@
 	--verbose
 
 %define debug_package %{nil}
-%setup -q -n ncurses-examples-%{version}
+%setup -q -n ncurses-examples-%{release}
 
 %build
 mkdir BUILD-W32
